DEV Community

codingpineapple
codingpineapple

Posted on

1

LeetCode 174. Dungeon Game (javascript solution)

Description:

Given a triangle array, return the minimum path sum from top The demons had captured the princess and imprisoned her in the bottom-right corner of a dungeon. The dungeon consists of m x n rooms laid out in a 2D grid. Our valiant knight was initially positioned in the top-left room and must fight his way through dungeon to rescue the princess.

The knight has an initial health point represented by a positive integer. If at any point his health point drops to 0 or below, he dies immediately.

Some of the rooms are guarded by demons (represented by negative integers), so the knight loses health upon entering these rooms; other rooms are either empty (represented as 0) or contain magic orbs that increase the knight's health (represented by positive integers).

To reach the princess as quickly as possible, the knight decides to move only rightward or downward in each step.

Return the knight's minimum initial health so that he can rescue the princess.

Note that any room can contain threats or power-ups, even the first room the knight enters and the bottom-right room where the princess is imprisoned.

Solution:

Time Complexity : O(n^2)
Space Complexity: O(n^2)

var calculateMinimumHP = function(dungeon) {
        let n = dungeon.length;
        let m = dungeon[0].length;

        // Create dp array
        const dp = Array(n + 1).fill(0).map(() => Array(m+1).fill(Infinity)) 
        // Create base cases
        dp[n][m - 1] = 1;
        dp[n - 1][m] = 1;

        // Loop through all the rows
        for (let i = n - 1; i >= 0; i--) {
            // Loop through all the cells
            for (let j = m - 1; j >= 0; j--) {
                // Get the minimum health needed to move to the next cell from the current cell without going to 0
                let need = Math.min(dp[i + 1][j], dp[i][j + 1]) - dungeon[i][j];                
                // If need <= 0 that means that dungeon[i][j] was positive. If a cell is positive the knight's health at minimum can be 1 because it does not cost any health to move there
                dp[i][j] = need <= 0 ? 1 : need;
            }
        }
        return dp[0][0];
};
Enter fullscreen mode Exit fullscreen mode

Neon image

Resources for building AI applications with Neon Postgres πŸ€–

Core concepts, starter applications, framework integrations, and deployment guides. Use these resources to build applications like RAG chatbots, semantic search engines, or custom AI tools.

Explore AI Tools β†’

Top comments (0)

Image of PulumiUP 2025

Let's talk about the current state of cloud and IaC, platform engineering, and security.

Dive into the stories and experiences of innovators and experts, from Startup Founders to Industry Leaders at PulumiUP 2025.

Register Now

πŸ‘‹ Kindness is contagious

Explore a trove of insights in this engaging article, celebrated within our welcoming DEV Community. Developers from every background are invited to join and enhance our shared wisdom.

A genuine "thank you" can truly uplift someone’s day. Feel free to express your gratitude in the comments below!

On DEV, our collective exchange of knowledge lightens the road ahead and strengthens our community bonds. Found something valuable here? A small thank you to the author can make a big difference.

Okay